import React from 'react';
import { storiesOf } from '@storybook/react';
import Button from '../button';

storiesOf('Button', module).addParameters({ component: Button }).add('Default', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Button,
      null,
      'Default'
    )
  );
}).add('Sizes', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Button,
      { size: 'xs' },
      'xs Button'
    ),
    React.createElement(
      Button,
      { size: 'sm' },
      'sm Button'
    ),
    React.createElement(
      Button,
      { size: 'md' },
      'md Button'
    ),
    React.createElement(
      Button,
      { size: 'lg' },
      'lg Button'
    ),
    React.createElement(
      Button,
      { size: 'xl' },
      'xl Button'
    )
  );
}).add('Spacing', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Button,
      { space: 'xs' },
      'xs Button'
    ),
    React.createElement(
      Button,
      { space: 'sm' },
      'sm Button'
    ),
    React.createElement(
      Button,
      { space: 'md' },
      'md Button'
    ),
    React.createElement(
      Button,
      { space: 'lg' },
      'lg Button'
    ),
    React.createElement(
      Button,
      { space: 'xl' },
      'xl Button'
    )
  );
}).add('Sizing + Spacing', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Button,
      { size: 'xs', space: 'xs' },
      'xs Button'
    ),
    React.createElement(
      Button,
      { size: 'sm', space: 'sm' },
      'sm Button'
    ),
    React.createElement(
      Button,
      { size: 'md', space: 'md' },
      'md Button'
    ),
    React.createElement(
      Button,
      { size: 'lg', space: 'lg' },
      'lg Button'
    ),
    React.createElement(
      Button,
      { size: 'xl', space: 'xl' },
      'xl Button'
    )
  );
});