var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  border-radius: 5px;\n  border: 2px solid ', ';\n  padding: 0;\n  overflow: hidden;\n  max-width: 100%;\n  max-height: 100%;\n  min-width: 0;\n  min-height: 0;\n  display: inline-flex;\n  :hover {\n    border: 2px solid ', ';\n  }\n'], ['\n  border-radius: 5px;\n  border: 2px solid ', ';\n  padding: 0;\n  overflow: hidden;\n  max-width: 100%;\n  max-height: 100%;\n  min-width: 0;\n  min-height: 0;\n  display: inline-flex;\n  :hover {\n    border: 2px solid ', ';\n  }\n']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n  position: relative;\n  width: 100%;\n  height: 100%;\n'], ['\n  position: relative;\n  width: 100%;\n  height: 100%;\n']),
    _templateObject3 = _taggedTemplateLiteralLoose(['\n  padding: 0;\n  position: relative;\n  display: block;\n  -webkit-box-flex: 0;\n  -ms-flex: 0 0 auto;\n  flex: 0 0 auto;\n  max-height: 100%;\n  max-width: 100%;\n'], ['\n  padding: 0;\n  position: relative;\n  display: block;\n  -webkit-box-flex: 0;\n  -ms-flex: 0 0 auto;\n  flex: 0 0 auto;\n  max-height: 100%;\n  max-width: 100%;\n']),
    _templateObject4 = _taggedTemplateLiteralLoose(['\n  ', ':hover & {\n    display: block;\n    background: ', ';\n  }\n  position: absolute;\n  bottom: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  display: none;\n  color: #fff;\n'], ['\n  ', ':hover & {\n    display: block;\n    background: ', ';\n  }\n  position: absolute;\n  bottom: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  display: none;\n  color: #fff;\n']),
    _templateObject5 = _taggedTemplateLiteralLoose(['\n  &&& {\n    color: #fff;\n    padding: 5%;\n  }\n'], ['\n  &&& {\n    color: #fff;\n    padding: 5%;\n  }\n']),
    _templateObject6 = _taggedTemplateLiteralLoose(['\n  &&& {\n    color: #fff;\n    padding: 0 5% 5% 5%;\n  }\n'], ['\n  &&& {\n    color: #fff;\n    padding: 0 5% 5% 5%;\n  }\n']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React from 'react';
import styled, { css, ThemeContext } from 'styled-components';
import { transparentize } from 'polished';
import PropTypes from 'prop-types';

import { clutchd, themeProps } from '../style/themes';
import { getTheme } from '../style/utils';

import Typography from '../typography';
var Paragraph = Typography.Paragraph,
    Heading = Typography.Heading;


var propTypes = {
  theme: themeProps,
  title: PropTypes.string,
  content: PropTypes.string,
  size: PropTypes.oneOf(['xs', 'sm', 'md', 'lg', 'xl']),
  space: PropTypes.oneOf(['xs', 'sm', 'md', 'lg', 'xl']),
  image: PropTypes.string,
  overlay: PropTypes.bool
};

var defaultProps = {
  theme: clutchd,
  size: 'md',
  space: 'md',
  image: undefined,
  overlay: false
};

// styles
var StyledCard = styled.div(_templateObject, function (props) {
  return transparentize(0.25, props.theme.colors.dark);
}, function (props) {
  return props.theme.colors.dark;
});

var StyledCardImageContainer = styled.div(_templateObject2);

var StyledCardImage = styled.img(_templateObject3);

var StyledCardImageOverlay = styled.div(_templateObject4, StyledCard, function (props) {
  return transparentize(0.25, props.theme.colors.dark);
});

var StyledCardImageOverlayTitle = styled(Heading)(_templateObject5);

var StyledCardImageOverlayContent = styled(Paragraph)(_templateObject6);

var Card = function Card(_ref) {
  var title = _ref.title,
      content = _ref.content,
      image = _ref.image,
      theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['title', 'content', 'image', 'theme', 'loading', 'children']);

  var currentTheme = getTheme(ThemeContext, theme);

  var imageOverlay = void 0;

  if (props.overlay) {
    imageOverlay = React.createElement(
      StyledCardImageOverlay,
      { theme: currentTheme },
      React.createElement(
        StyledCardImageOverlayTitle,
        null,
        title
      ),
      React.createElement(
        StyledCardImageOverlayContent,
        null,
        content
      )
    );
  }

  return React.createElement(
    StyledCard,
    _extends({ theme: currentTheme }, props),
    image ? React.createElement(
      StyledCardImageContainer,
      { theme: currentTheme },
      React.createElement(StyledCardImage, { theme: currentTheme, src: image }),
      imageOverlay
    ) : React.createElement(
      React.Fragment,
      null,
      children
    )
  );
};

Card.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Card.defaultProps = defaultProps;

export default Card;