var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n    flex: 0 0 ', ';\n    max-width: ', ';\n  '], ['\n    flex: 0 0 ', ';\n    max-width: ', ';\n  ']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n  &&& {\n    display: flex;\n    position: relative;\n    width: 100%;\n    margin: 0;\n    flex-direction: column;\n    ', ';\n  }\n  @media (max-width: 575px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 576px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 728px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 992px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1200px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1600px) {\n    &&& {\n      ', ';\n    }\n  }\n'], ['\n  &&& {\n    display: flex;\n    position: relative;\n    width: 100%;\n    margin: 0;\n    flex-direction: column;\n    ', ';\n  }\n  @media (max-width: 575px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 576px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 728px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 992px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1200px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1600px) {\n    &&& {\n      ', ';\n    }\n  }\n']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React, { useEffect } from 'react';
import styled, { css, ThemeContext } from 'styled-components';
import PropTypes from 'prop-types';
import Grid from './grid';

import { clutchd, themeProps } from '../style/themes';
import { getTheme } from '../style/utils';

var propTypes = {
  theme: themeProps,
  /** Number of 'cells' that a Col will occupy (24 total cells) */
  span: PropTypes.number,
  /** span of Col when page is <576px */
  xs: PropTypes.number,
  /** span of Col when page is >=576px */
  sm: PropTypes.number,
  /** span of Col when page is >=728px */
  md: PropTypes.number,
  /** span of Col when page is >=992px */
  lg: PropTypes.number,
  /** span of Col when page is >=1200px */
  xl: PropTypes.number,
  /** span of Col when page is >=1600px */
  xxl: PropTypes.number
};

var defaultProps = {
  theme: clutchd
};

var setSpan = function setSpan(span) {
  return css(_templateObject, span / 24 * 100 + '%', span / 24 * 100 + '%');
};

export var StyledCol = styled(Grid)(_templateObject2, function (props) {
  return props.span ? setSpan(props.span) : '';
}, function (props) {
  return props.xs ? setSpan(props.xs) : '';
}, function (props) {
  return props.sm ? setSpan(props.sm) : '';
}, function (props) {
  return props.md ? setSpan(props.md) : '';
}, function (props) {
  return props.lg ? setSpan(props.lg) : '';
}, function (props) {
  return props.xl ? setSpan(props.xl) : '';
}, function (props) {
  return props.xxl ? setSpan(props.xxl) : '';
});

/**
 * The `Col` component...
 */
var Col = function Col(_ref) {
  var theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['theme', 'loading', 'children']);

  var currentTheme = getTheme(ThemeContext, theme);

  return React.createElement(
    StyledCol,
    _extends({ theme: currentTheme }, props),
    loading ? children : React.createElement(
      React.Fragment,
      null,
      children
    )
  );
};

Col.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Col.defaultProps = defaultProps;

export default Col;