import React from 'react';
import { storiesOf } from '@storybook/react';
import Typography from '../typography';
var Text = Typography.Text;


import Grid from '../grid';
var Row = Grid.Row,
    Col = Grid.Col;


storiesOf('Grid', module).addParameters({ component: Grid }).add('Default', function () {
  return React.createElement(
    Row,
    null,
    React.createElement(
      Col,
      null,
      React.createElement(
        Text,
        null,
        'Col 1'
      )
    )
  );
});

storiesOf('Grid.Row', module).addParameters({ component: Row }).add('Default', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Row,
      { gutter: 16 },
      React.createElement(
        Col,
        { span: 24 },
        React.createElement(
          Text,
          null,
          'Col 1'
        )
      )
    ),
    React.createElement(
      Row,
      { gutter: 16 },
      React.createElement(
        Col,
        { span: 12 },
        React.createElement(
          Text,
          null,
          'Col 2'
        )
      ),
      React.createElement(
        Col,
        { span: 12 },
        React.createElement(
          Text,
          null,
          'Col 3'
        )
      )
    )
  );
});

storiesOf('Grid.Col', module).addParameters({ component: Col }).add('Default', function () {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      Row,
      null,
      React.createElement(
        Col,
        { span: 24 },
        React.createElement(
          Text,
          null,
          'Col 1'
        )
      )
    ),
    React.createElement(
      Row,
      null,
      React.createElement(
        Col,
        { span: 12 },
        React.createElement(
          Text,
          null,
          'Col 2'
        )
      ),
      React.createElement(
        Col,
        { span: 12 },
        React.createElement(
          Text,
          null,
          'Col 3'
        )
      )
    )
  );
});