import React from 'react';
import { storiesOf } from '@storybook/react';
import Typography from '../typography';
var Text = Typography.Text;


import Layout from '../layout';
var Header = Layout.Header,
    Main = Layout.Main,
    Footer = Layout.Footer;


import Grid from '../grid';
var Row = Grid.Row,
    Col = Grid.Col;


storiesOf('Layout', module).addParameters({ component: Layout }).add('Default', function () {
  return React.createElement(
    Layout,
    null,
    React.createElement(
      Header,
      null,
      React.createElement(
        Row,
        { align: 'stretch' },
        React.createElement(
          Col,
          { span: 6 },
          React.createElement(
            Text,
            null,
            'Logo'
          )
        ),
        React.createElement(
          Col,
          { span: 18, align: 'end' },
          React.createElement(
            Text,
            null,
            'Menu'
          )
        )
      )
    ),
    React.createElement(
      Main,
      null,
      React.createElement(
        Text,
        null,
        'This is a Main component'
      )
    ),
    React.createElement(
      Footer,
      null,
      React.createElement(
        Text,
        null,
        'This is a Footer component'
      )
    )
  );
});