import React from 'react';
import { ThemeProvider, ThemeContext } from 'styled-components';
import { clutchd, themeProps } from './themes';
import { getTheme } from './utils';

var propTypes = {
  theme: themeProps
};

var defaultProps = {
  theme: clutchd
};

/**
 * The `Themed` component is simply a modified ThemeProvider from styled-components.  This component comes will all the default stylings of @clutchd/ui.
 */
var Style = function Style(_ref) {
  var theme = _ref.theme,
      children = _ref.children;

  var currentTheme = getTheme(ThemeContext, theme);

  return React.createElement(
    ThemeProvider,
    { theme: currentTheme },
    React.createElement(
      React.Fragment,
      null,
      children
    )
  );
};

Style.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Style.defaultProps = defaultProps;

export default Style;