var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import { storiesOf } from '@storybook/react';

import { clutchd } from './themes';

import Style from '.';
import Button from '../button';

storiesOf('Style', module).addParameters({ component: Style }).add('Default', function () {
  return React.createElement(
    Button,
    null,
    'Test'
  );
}).add('Primary Color', function () {
  return (
    /** For larger theme changes, a custom theme object should be created
     *
     * <Styletheme={newTheme}>
     *   <Button>Test</Button>
     * </Style>
     *
     */

    React.createElement(
      Style,
      {
        theme: _extends({}, clutchd, {
          colors: _extends({}, clutchd.colors, {
            primary: 'green'
          })
        })
      },
      React.createElement(
        Button,
        null,
        'Test'
      )
    )
  );
});