var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  &&& {\n    font-size: ', ';\n    font-weight: ', ';\n    margin: 0 0 0.5em 0;\n    margin-block-start: 0;\n    margin-block-end: 0.5em;\n    margin-inline-start: 0;\n    margin-inline-end: 0;\n    line-height: 1.25;\n    padding: 0;\n  }\n  * + &&& {\n    margin: 1.2em 0 0.5em 0;\n  }\n'], ['\n  &&& {\n    font-size: ', ';\n    font-weight: ', ';\n    margin: 0 0 0.5em 0;\n    margin-block-start: 0;\n    margin-block-end: 0.5em;\n    margin-inline-start: 0;\n    margin-inline-end: 0;\n    line-height: 1.25;\n    padding: 0;\n  }\n  * + &&& {\n    margin: 1.2em 0 0.5em 0;\n  }\n']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React, { useEffect } from 'react';
import Prism from 'prismjs';
import styled, { css } from 'styled-components';
import PropTypes from 'prop-types';
import { StyledTypography, getWrapper } from './typography';

var propTypes = {
  /** Heading level (h1-h6) */
  level: PropTypes.number
};

var defaultProps = {
  level: 1
};

var headingFontSize = new Map([[1, '32px'], [2, '24px'], [3, '20px'], [4, '16px'], [5, '14px'], [6, '13px']]);

var StyledHeading = styled(StyledTypography)(_templateObject, function (props) {
  return headingFontSize.get(props.level);
}, function (props) {
  return props.strong ? 700 : 600;
});

/** The `Heading` component is meant to be used for all heading text. (h1-h6, titles, etc.) */
var Heading = function Heading(_ref) {
  var level = _ref.level,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['level', 'loading', 'children']);

  var Wrapper = getWrapper(props);

  if (props.code) {
    useEffect(function () {
      Prism.highlightAll();
    }, [children]);
  }

  return React.createElement(
    Wrapper,
    null,
    React.createElement(
      StyledHeading,
      _extends({ as: 'h' + level, level: level }, props),
      loading ? children : children
    )
  );
};

Heading.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Heading.defaultProps = defaultProps;

export default Heading;