import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';

import Typography from '../typography';
var Heading = Typography.Heading,
    Paragraph = Typography.Paragraph,
    Text = Typography.Text;


storiesOf('Typography', module).addParameters({ component: Typography }).add('Default', function () {
  return React.createElement(
    'div',
    null,
    React.createElement(
      Typography,
      null,
      React.createElement(
        Heading,
        null,
        'Overview'
      ),
      React.createElement(
        Paragraph,
        null,
        'Lorem ipsum dolor sit amet,',
        ' ',
        React.createElement(
          Text,
          { strikethrough: true },
          'consectetur adipiscing elit'
        ),
        ', sed do eiusmod tempor incididunt ut ',
        React.createElement(
          Text,
          { code: true },
          'labore et dolore'
        ),
        ' magna aliqua.',
        React.createElement(
          Text,
          { mark: true },
          'Ut enim ad'
        ),
        ' minim veniam, quis nostrud exercitation',
        React.createElement(
          Text,
          { disable: true },
          ' ullamco laboris nisi'
        ),
        ' ut aliquip ex ea commodo consequat. ',
        React.createElement(
          Text,
          { strong: true },
          'Duis aute irure'
        ),
        ' dolor in reprehenderit in voluptate velit esse ',
        React.createElement(
          Text,
          { emphasis: true },
          'cillum dolore eu'
        ),
        ' fugiat nulla pariatur. Excepteur sint occaecat cupidatat',
        ' ',
        React.createElement(
          Text,
          { underline: true },
          'non proident'
        ),
        ', sunt in culpa qui officia deserunt mollit anim id est laborum.'
      ),
      React.createElement(
        Text,
        { pre: true, code: true },
        'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
      ),
      React.createElement(
        Heading,
        { level: 2 },
        'Sub Topic'
      ),
      React.createElement(
        Paragraph,
        null,
        'Lorem ipsum dolor sit amet,',
        ' ',
        React.createElement(
          Text,
          { strikethrough: true },
          'consectetur adipiscing elit'
        ),
        ', sed do eiusmod tempor incididunt ut',
        ' ',
        React.createElement(
          Text,
          { code: true, className: 'language-javascript' },
          'class TodoApp extends React.Component {'
        ),
        ' ',
        'magna aliqua.',
        React.createElement(
          Text,
          { mark: true },
          'Ut enim ad'
        ),
        ' minim veniam, quis nostrud exercitation',
        React.createElement(
          Text,
          { disable: true },
          ' ullamco laboris nisi'
        ),
        ' ut aliquip ex ea commodo consequat. ',
        React.createElement(
          Text,
          { strong: true },
          'Duis aute irure'
        ),
        ' dolor in reprehenderit in voluptate velit esse ',
        React.createElement(
          Text,
          { emphasis: true },
          'cillum dolore eu'
        ),
        ' fugiat nulla pariatur. Excepteur sint occaecat cupidatat',
        ' ',
        React.createElement(
          Text,
          { underline: true },
          'non proident'
        ),
        ', sunt in culpa qui officia deserunt mollit anim id est laborum.'
      )
    ),
    React.createElement(
      Typography,
      null,
      React.createElement(
        Heading,
        null,
        'Overview'
      ),
      React.createElement(
        Paragraph,
        null,
        'Lorem ipsum dolor sit amet,',
        ' ',
        React.createElement(
          Text,
          { strikethrough: true },
          'consectetur adipiscing elit'
        ),
        ', sed do eiusmod tempor incididunt ut ',
        React.createElement(
          Text,
          { code: true },
          'labore et dolore'
        ),
        ' magna aliqua.',
        React.createElement(
          Text,
          { mark: true },
          'Ut enim ad'
        ),
        ' minim veniam, quis nostrud exercitation',
        React.createElement(
          Text,
          { disable: true },
          ' ullamco laboris nisi'
        ),
        ' ut aliquip ex ea commodo consequat. ',
        React.createElement(
          Text,
          { strong: true },
          'Duis aute irure'
        ),
        ' dolor in reprehenderit in voluptate velit esse ',
        React.createElement(
          Text,
          { emphasis: true },
          'cillum dolore eu'
        ),
        ' fugiat nulla pariatur. Excepteur sint occaecat cupidatat',
        ' ',
        React.createElement(
          Text,
          { underline: true },
          'non proident'
        ),
        ', sunt in culpa qui officia deserunt mollit anim id est laborum.'
      ),
      React.createElement(
        Text,
        { blockquote: true },
        'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
      ),
      React.createElement(
        Heading,
        { level: 2 },
        'Sub Topic'
      ),
      React.createElement(
        Paragraph,
        null,
        'Lorem ipsum dolor sit amet,',
        ' ',
        React.createElement(
          Text,
          { strikethrough: true },
          'consectetur adipiscing elit'
        ),
        ', sed do eiusmod tempor incididunt ut',
        ' ',
        React.createElement(
          Text,
          { code: true, className: 'language-javascript' },
          'class TodoApp extends React.Component {'
        ),
        ' ',
        'magna aliqua.',
        React.createElement(
          Text,
          { mark: true },
          'Ut enim ad'
        ),
        ' minim veniam, quis nostrud exercitation',
        React.createElement(
          Text,
          { disable: true },
          ' ullamco laboris nisi'
        ),
        ' ut aliquip ex ea commodo consequat. ',
        React.createElement(
          Text,
          { strong: true },
          'Duis aute irure'
        ),
        ' dolor in reprehenderit in voluptate velit esse ',
        React.createElement(
          Text,
          { emphasis: true },
          'cillum dolore eu'
        ),
        ' fugiat nulla pariatur. Excepteur sint occaecat cupidatat',
        ' ',
        React.createElement(
          Text,
          { underline: true },
          'non proident'
        ),
        ', sunt in culpa qui officia deserunt mollit anim id est laborum.'
      ),
      React.createElement(
        Text,
        { pre: true, code: true, className: 'language-javascript' },
        'onSubmit(e) {\n  e.preventDefault();\n  const job = {\n    title: \'Developer\',\n    company: \'Facebook\' \n  };\n}'
      )
    )
  );
});

storiesOf('Typography.Heading', module).addParameters({ component: Heading }).add('Default', function () {
  return React.createElement(
    'div',
    null,
    React.createElement(
      Heading,
      { level: 1 },
      'Hello World!'
    ),
    React.createElement(
      Heading,
      { level: 2 },
      'Hello World!'
    ),
    React.createElement(
      Heading,
      { level: 3 },
      'Hello World!'
    ),
    React.createElement(
      Heading,
      { level: 4 },
      'Hello World!'
    ),
    React.createElement(
      Heading,
      { level: 5 },
      'Hello World!'
    ),
    React.createElement(
      Heading,
      { level: 6 },
      'Hello World!'
    )
  );
});

storiesOf('Typography.Paragraph', module).addParameters({ component: Paragraph }).add('Default', function () {
  return React.createElement(
    Paragraph,
    null,
    'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.'
  );
});

storiesOf('Typography.Text', module).addParameters({ component: Text }).add('Default', function () {
  return React.createElement(
    Text,
    null,
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Inline Code', function () {
  return React.createElement(
    'div',
    null,
    React.createElement(
      Text,
      { code: true },
      'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
    ),
    React.createElement('br', null),
    React.createElement(
      Text,
      { code: true, className: 'language-javascript' },
      'class TodoApp extends React.Component {'
    )
  );
}).add('Preformatted Code', function () {
  return React.createElement(
    'div',
    null,
    React.createElement(
      Text,
      { pre: true, code: true },
      'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
    ),
    React.createElement(
      Text,
      { pre: true, code: true, className: 'language-javascript' },
      'class TodoApp extends React.Component {'
    )
  );
}).add('Code Highlighting', function () {
  return React.createElement(
    Text,
    { pre: true, code: true, className: 'language-javascript' },
    'class TodoApp extends React.Component {\n  constructor(props) {\n    super(props);\n    this.state = { items: [], text: \'\' };\n    this.handleChange = this.handleChange.bind(this);\n    this.handleSubmit = this.handleSubmit.bind(this);\n  }\n\n  render() {\n    return (\n      <div>\n        <h3>TODO</h3>\n        <TodoList items={this.state.items} />\n        <form onSubmit={this.handleSubmit}>\n          <label htmlFor="new-todo">\n            What needs to be done?\n          </label>\n          <input\n            id="new-todo"\n            onChange={this.handleChange}\n            value={this.state.text}\n          />\n          <button>\n            Add #{this.state.items.length + 1}\n          </button>\n        </form>\n      </div>\n    );\n  }\n\n  handleChange(e) {\n    this.setState({ text: e.target.value });\n  }\n\n  handleSubmit(e) {\n    e.preventDefault();\n    if (!this.state.text.length) {\n      return;\n    }\n    const newItem = {\n      text: this.state.text,\n      id: Date.now()\n    };\n    this.setState(state => ({\n      items: state.items.concat(newItem),\n      text: \'\'\n    }));\n  }\n}\n\nclass TodoList extends React.Component {\n  render() {\n    return (\n      <ul>\n        {this.props.items.map(item => (\n          <li key={item.id}>{item.text}</li>\n        ))}\n      </ul>\n    );\n  }\n}\n\nReactDOM.render(\n  <TodoApp />,\n  document.getElementById(\'todos-example\')\n);'
  );
}).add('Disabled', function () {
  return React.createElement(
    Text,
    { disable: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Emphasis', function () {
  return React.createElement(
    Text,
    { emphasis: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Mark', function () {
  return React.createElement(
    Text,
    { mark: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Strikethrough', function () {
  return React.createElement(
    Text,
    { strikethrough: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Strong', function () {
  return React.createElement(
    Text,
    { strong: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
}).add('Underlined', function () {
  return React.createElement(
    Text,
    { underline: true },
    'Lorem ipsum eiusmod tempor incididunt ut labore et dolore magna aliqua.'
  );
});