'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  border-radius: 5px;\n  border: 2px solid ', ';\n  padding: 0;\n  overflow: hidden;\n  max-width: 100%;\n  max-height: 100%;\n  min-width: 0;\n  min-height: 0;\n  display: inline-flex;\n  :hover {\n    border: 2px solid ', ';\n  }\n'], ['\n  border-radius: 5px;\n  border: 2px solid ', ';\n  padding: 0;\n  overflow: hidden;\n  max-width: 100%;\n  max-height: 100%;\n  min-width: 0;\n  min-height: 0;\n  display: inline-flex;\n  :hover {\n    border: 2px solid ', ';\n  }\n']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n  position: relative;\n  width: 100%;\n  height: 100%;\n'], ['\n  position: relative;\n  width: 100%;\n  height: 100%;\n']),
    _templateObject3 = _taggedTemplateLiteralLoose(['\n  padding: 0;\n  position: relative;\n  display: block;\n  -webkit-box-flex: 0;\n  -ms-flex: 0 0 auto;\n  flex: 0 0 auto;\n  max-height: 100%;\n  max-width: 100%;\n'], ['\n  padding: 0;\n  position: relative;\n  display: block;\n  -webkit-box-flex: 0;\n  -ms-flex: 0 0 auto;\n  flex: 0 0 auto;\n  max-height: 100%;\n  max-width: 100%;\n']),
    _templateObject4 = _taggedTemplateLiteralLoose(['\n  ', ':hover & {\n    display: block;\n    background: ', ';\n  }\n  position: absolute;\n  bottom: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  display: none;\n  color: #fff;\n'], ['\n  ', ':hover & {\n    display: block;\n    background: ', ';\n  }\n  position: absolute;\n  bottom: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  display: none;\n  color: #fff;\n']),
    _templateObject5 = _taggedTemplateLiteralLoose(['\n  &&& {\n    color: #fff;\n    padding: 5%;\n  }\n'], ['\n  &&& {\n    color: #fff;\n    padding: 5%;\n  }\n']),
    _templateObject6 = _taggedTemplateLiteralLoose(['\n  &&& {\n    color: #fff;\n    padding: 0 5% 5% 5%;\n  }\n'], ['\n  &&& {\n    color: #fff;\n    padding: 0 5% 5% 5%;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _polished = require('polished');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _themes = require('../style/themes');

var _utils = require('../style/utils');

var _typography = require('../typography');

var _typography2 = _interopRequireDefault(_typography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var Paragraph = _typography2.default.Paragraph,
    Heading = _typography2.default.Heading;


var propTypes = {
  theme: _themes.themeProps,
  title: _propTypes2.default.string,
  content: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['xs', 'sm', 'md', 'lg', 'xl']),
  space: _propTypes2.default.oneOf(['xs', 'sm', 'md', 'lg', 'xl']),
  image: _propTypes2.default.string,
  overlay: _propTypes2.default.bool
};

var defaultProps = {
  theme: _themes.clutchd,
  size: 'md',
  space: 'md',
  image: undefined,
  overlay: false
};

// styles
var StyledCard = _styledComponents2.default.div(_templateObject, function (props) {
  return (0, _polished.transparentize)(0.25, props.theme.colors.dark);
}, function (props) {
  return props.theme.colors.dark;
});

var StyledCardImageContainer = _styledComponents2.default.div(_templateObject2);

var StyledCardImage = _styledComponents2.default.img(_templateObject3);

var StyledCardImageOverlay = _styledComponents2.default.div(_templateObject4, StyledCard, function (props) {
  return (0, _polished.transparentize)(0.25, props.theme.colors.dark);
});

var StyledCardImageOverlayTitle = (0, _styledComponents2.default)(Heading)(_templateObject5);

var StyledCardImageOverlayContent = (0, _styledComponents2.default)(Paragraph)(_templateObject6);

var Card = function Card(_ref) {
  var title = _ref.title,
      content = _ref.content,
      image = _ref.image,
      theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['title', 'content', 'image', 'theme', 'loading', 'children']);

  var currentTheme = (0, _utils.getTheme)(_styledComponents.ThemeContext, theme);

  var imageOverlay = void 0;

  if (props.overlay) {
    imageOverlay = _react2.default.createElement(
      StyledCardImageOverlay,
      { theme: currentTheme },
      _react2.default.createElement(
        StyledCardImageOverlayTitle,
        null,
        title
      ),
      _react2.default.createElement(
        StyledCardImageOverlayContent,
        null,
        content
      )
    );
  }

  return _react2.default.createElement(
    StyledCard,
    _extends({ theme: currentTheme }, props),
    image ? _react2.default.createElement(
      StyledCardImageContainer,
      { theme: currentTheme },
      _react2.default.createElement(StyledCardImage, { theme: currentTheme, src: image }),
      imageOverlay
    ) : _react2.default.createElement(
      _react2.default.Fragment,
      null,
      children
    )
  );
};

Card.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Card.defaultProps = defaultProps;

exports.default = Card;
module.exports = exports['default'];