'use strict';

exports.__esModule = true;
exports.StyledCol = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n    flex: 0 0 ', ';\n    max-width: ', ';\n  '], ['\n    flex: 0 0 ', ';\n    max-width: ', ';\n  ']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n  &&& {\n    display: flex;\n    position: relative;\n    width: 100%;\n    margin: 0;\n    flex-direction: column;\n    ', ';\n  }\n  @media (max-width: 575px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 576px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 728px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 992px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1200px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1600px) {\n    &&& {\n      ', ';\n    }\n  }\n'], ['\n  &&& {\n    display: flex;\n    position: relative;\n    width: 100%;\n    margin: 0;\n    flex-direction: column;\n    ', ';\n  }\n  @media (max-width: 575px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 576px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 728px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 992px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1200px) {\n    &&& {\n      ', ';\n    }\n  }\n  @media (min-width: 1600px) {\n    &&& {\n      ', ';\n    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _grid = require('./grid');

var _grid2 = _interopRequireDefault(_grid);

var _themes = require('../style/themes');

var _utils = require('../style/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var propTypes = {
  theme: _themes.themeProps,
  /** Number of 'cells' that a Col will occupy (24 total cells) */
  span: _propTypes2.default.number,
  /** span of Col when page is <576px */
  xs: _propTypes2.default.number,
  /** span of Col when page is >=576px */
  sm: _propTypes2.default.number,
  /** span of Col when page is >=728px */
  md: _propTypes2.default.number,
  /** span of Col when page is >=992px */
  lg: _propTypes2.default.number,
  /** span of Col when page is >=1200px */
  xl: _propTypes2.default.number,
  /** span of Col when page is >=1600px */
  xxl: _propTypes2.default.number
};

var defaultProps = {
  theme: _themes.clutchd
};

var setSpan = function setSpan(span) {
  return (0, _styledComponents.css)(_templateObject, span / 24 * 100 + '%', span / 24 * 100 + '%');
};

var StyledCol = exports.StyledCol = (0, _styledComponents2.default)(_grid2.default)(_templateObject2, function (props) {
  return props.span ? setSpan(props.span) : '';
}, function (props) {
  return props.xs ? setSpan(props.xs) : '';
}, function (props) {
  return props.sm ? setSpan(props.sm) : '';
}, function (props) {
  return props.md ? setSpan(props.md) : '';
}, function (props) {
  return props.lg ? setSpan(props.lg) : '';
}, function (props) {
  return props.xl ? setSpan(props.xl) : '';
}, function (props) {
  return props.xxl ? setSpan(props.xxl) : '';
});

/**
 * The `Col` component...
 */
var Col = function Col(_ref) {
  var theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['theme', 'loading', 'children']);

  var currentTheme = (0, _utils.getTheme)(_styledComponents.ThemeContext, theme);

  return _react2.default.createElement(
    StyledCol,
    _extends({ theme: currentTheme }, props),
    loading ? children : _react2.default.createElement(
      _react2.default.Fragment,
      null,
      children
    )
  );
};

Col.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Col.defaultProps = defaultProps;

exports.default = Col;