'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  &&& {\n    box-sizing: border-box;\n    align-content: ', ';\n    align-items: ', ';\n  }\n'], ['\n  &&& {\n    box-sizing: border-box;\n    align-content: ', ';\n    align-items: ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _themes = require('../style/themes');

var _utils = require('../style/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var propTypes = {
  theme: _themes.themeProps,
  /** Determines flex position */
  align: _propTypes2.default.oneOf(['center', 'end', 'start', 'stretch'])
};

var defaultProps = {
  theme: _themes.clutchd,
  align: 'center'
};

var StyledGrid = _styledComponents2.default.div(_templateObject, function (props) {
  return (props.align === 'start' || props.align === 'end' ? 'flex-' : '') + props.align;
}, function (props) {
  return (props.align === 'start' || props.align === 'end' ? 'flex-' : '') + props.align;
});

/**
 * The `Grid` component...
 */
var Grid = function Grid(_ref) {
  var theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['theme', 'loading', 'children']);

  var currentTheme = (0, _utils.getTheme)(_styledComponents.ThemeContext, theme);

  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      StyledGrid,
      _extends({ theme: currentTheme }, props),
      loading ? children : _react2.default.createElement(
        _react2.default.Fragment,
        null,
        children
      )
    )
  );
};

Grid.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Grid.defaultProps = defaultProps;

exports.default = Grid;
module.exports = exports['default'];