'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  &&& {\n    display: flex;\n    flex-wrap: wrap;\n    padding: 0;\n    width: 100%;\n    justify-content: ', ';\n    flex-direction: row;\n  }\n  &&& > * {\n    padding-left: ', ';\n    padding-right: ', ';\n  }\n  &&& + &&& {\n    margin-top: ', ';\n  }\n'], ['\n  &&& {\n    display: flex;\n    flex-wrap: wrap;\n    padding: 0;\n    width: 100%;\n    justify-content: ', ';\n    flex-direction: row;\n  }\n  &&& > * {\n    padding-left: ', ';\n    padding-right: ', ';\n  }\n  &&& + &&& {\n    margin-top: ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _grid = require('./grid');

var _grid2 = _interopRequireDefault(_grid);

var _themes = require('../style/themes');

var _utils = require('../style/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var propTypes = {
  theme: _themes.themeProps,
  /** Spacing between Cols (px) */
  gutter: _propTypes2.default.number,
  /** Determines horizontal position */
  justify: _propTypes2.default.oneOf(['center', 'end', 'space-around', 'space-between', 'space-evenly', 'start'])
};

var defaultProps = {
  theme: _themes.clutchd,
  gutter: 0,
  justify: 'start'
};

var StyledRow = (0, _styledComponents2.default)(_grid2.default)(_templateObject, function (props) {
  return (props.justify === 'start' || props.justify === 'end' ? 'flex-' : '') + props.justify;
}, function (props) {
  return props.gutter + 'px';
}, function (props) {
  return props.gutter + 'px';
}, function (props) {
  return props.gutter + 'px';
});

/**
 * The `Row` component...
 */
var Row = function Row(_ref) {
  var theme = _ref.theme,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['theme', 'loading', 'children']);

  var currentTheme = (0, _utils.getTheme)(_styledComponents.ThemeContext, theme);

  return _react2.default.createElement(
    StyledRow,
    _extends({ theme: currentTheme }, props),
    loading ? children : _react2.default.createElement(
      _react2.default.Fragment,
      null,
      children
    )
  );
};

Row.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Row.defaultProps = defaultProps;

exports.default = Row;
module.exports = exports['default'];