'use strict';

exports.__esModule = true;
exports.clutchd = exports.themeProps = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var themeProps = {
  theme: _propTypes2.default.shape({
    colors: _propTypes2.default.shape({
      primary: _propTypes2.default.string,
      secondary: _propTypes2.default.string,
      light: _propTypes2.default.string,
      dark: _propTypes2.default.string,
      info: _propTypes2.default.string,
      success: _propTypes2.default.string,
      warning: _propTypes2.default.string,
      danger: _propTypes2.default.string
    }),
    sizes: _propTypes2.default.shape({
      xs: _propTypes2.default.string,
      sm: _propTypes2.default.string,
      md: _propTypes2.default.string,
      lg: _propTypes2.default.string,
      xl: _propTypes2.default.string
    }),
    spaces: _propTypes2.default.shape({
      xs: _propTypes2.default.string,
      sm: _propTypes2.default.string,
      md: _propTypes2.default.string,
      lg: _propTypes2.default.string,
      xl: _propTypes2.default.string
    })
  })
};

exports.themeProps = themeProps = themeProps.theme;
exports.themeProps = themeProps;

/** Default theme for @clutchd/ui */

var clutchd = {
  theme: {
    colors: {
      primary: '#AF7AC5',
      secondary: 'rgba(136, 217, 230, 1)',
      light: 'rgba(255, 255, 255, 1)',
      dark: '#17202A',
      info: 'rgba(136, 217, 230, 1)',
      success: 'rgba(66, 255, 66, 1)',
      warning: 'rgba(255, 255, 66, 1)',
      danger: 'rgba(255, 66, 66, 1)'
    },
    sizes: {
      xs: '1em',
      sm: '1.5em',
      md: '2em',
      lg: '2.5em',
      xl: '3em'
    },
    spaces: {
      xs: '0.05em 0.25em',
      sm: '0.075em 0.375em',
      md: '0.1em 0.5em',
      lg: '0.15em 0.75em',
      xl: '0.2em 1em'
    }
  }
};

exports.clutchd = clutchd = clutchd.theme;
exports.clutchd = clutchd;