'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  &&& {\n    font-size: ', ';\n    font-weight: ', ';\n    margin: 0 0 0.5em 0;\n    margin-block-start: 0;\n    margin-block-end: 0.5em;\n    margin-inline-start: 0;\n    margin-inline-end: 0;\n    line-height: 1.25;\n    padding: 0;\n  }\n  * + &&& {\n    margin: 1.2em 0 0.5em 0;\n  }\n'], ['\n  &&& {\n    font-size: ', ';\n    font-weight: ', ';\n    margin: 0 0 0.5em 0;\n    margin-block-start: 0;\n    margin-block-end: 0.5em;\n    margin-inline-start: 0;\n    margin-inline-end: 0;\n    line-height: 1.25;\n    padding: 0;\n  }\n  * + &&& {\n    margin: 1.2em 0 0.5em 0;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _prismjs = require('prismjs');

var _prismjs2 = _interopRequireDefault(_prismjs);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _typography = require('./typography');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var propTypes = {
  /** Heading level (h1-h6) */
  level: _propTypes2.default.number
};

var defaultProps = {
  level: 1
};

var headingFontSize = new Map([[1, '32px'], [2, '24px'], [3, '20px'], [4, '16px'], [5, '14px'], [6, '13px']]);

var StyledHeading = (0, _styledComponents2.default)(_typography.StyledTypography)(_templateObject, function (props) {
  return headingFontSize.get(props.level);
}, function (props) {
  return props.strong ? 700 : 600;
});

/** The `Heading` component is meant to be used for all heading text. (h1-h6, titles, etc.) */
var Heading = function Heading(_ref) {
  var level = _ref.level,
      loading = _ref.loading,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['level', 'loading', 'children']);

  var Wrapper = (0, _typography.getWrapper)(props);

  if (props.code) {
    (0, _react.useEffect)(function () {
      _prismjs2.default.highlightAll();
    }, [children]);
  }

  return _react2.default.createElement(
    Wrapper,
    null,
    _react2.default.createElement(
      StyledHeading,
      _extends({ as: 'h' + level, level: level }, props),
      loading ? children : children
    )
  );
};

Heading.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
Heading.defaultProps = defaultProps;

exports.default = Heading;
module.exports = exports['default'];